package com.eactive.eai.batch.job.jobItem.wis;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_LDB01_0610 extends DefaultTelegram implements TelegramService {

    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이
    private Properties telegramInfo;
    /**
     * 생성자
     */
    public SEND_LDB01_0610() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;

            //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);

            // 해당 Transaction을 기동하는 코드로 본 파일전송 업무는 “KFBFTP”문자를 사용한다.
//            compileField(1, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[1]);

            //업무구분코드 -업무구분을 위하여 Set하는 문자로 본 파일전송 업무에서는 “FTP”문자를 사용키로 한다.
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);

            //대표기관코드 - 전문관련 금융기관을 나타내는 코드로서 금융기관 공동코드 (7자리)중 상위 3자리 금융기관 대표코드를 사용한다.
            // Ex) 국민: 004, 부산: 032, 농협: 011 등
            compileField(3, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[3]);

            //전문종별코드. 전문의 기능을 나타내는 구분코드로 전문종류별로 해당 전문코드를 Set하며 세부사항은 표준화 사항의 전문종별 코드를 참조한다.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);

            //거래구분코드
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //송수신 FLAG 전문을 발생시킨 기관을 나타내는 코드로 아래의 값중 해당코드를 Set한다.
            //“C”: 은행연합회에서 전문을 발생할 시
            //“B”: 은행에서 전문을 발생할 시
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[6]);

            //응답코드
            compileField(7, TelegramKeys.KFB_RET_CODE_SUCCESS, this.al_FieldProps[7]);

            //전송기준일자
            compileField(8, batchDoc.getBatchMsg().getHeader().getBaseDate(), this.al_FieldProps[8]);

            //업무별 Record Length -송수신을 하고자 하는 자료의 Record Length를 Set 한다.
            compileField(9, ""+SEND_LENGTH, this.al_FieldProps[9]);

            //송수신 업무 구분코드. 은행연합회를 기준으로 하여 해당전문이 송수신업무 중 어느 업무에 관련된 것인지를 구분하기 위한 코드로 아래 값 중 해당코드를 Set한다.
            //“S”: 파일 송신업무 관련 전문 (은행연합회 → 은행)
            //“R”: 파일 수신업무 관련 전문 (은행 → 은행연합회)
            compileField(10, getFldTrClass() , this.al_FieldProps[10]);

            //전문 전송 일시 - 전문을 발신하는 기관에서 전문을 전송하는 일자와 시간을 Set한다.
            compileField(11, TelegramKeys.getMMddHHmmss(), this.al_FieldProps[11]);

            //업무 관리 정보 - 파일전송업무 관리를 위한 정보로 아래의 값 중 하나를 Set 한다.
            // “001”: 개별 업무 개시 “002”: 파일 송?수신 계속
            // “003”: 개별 업무 종료 “008”: 송신 시작 요구
            // “301”: 업무 장애 회복 확인
            compileField(12, this.getFldOpCode(), this.al_FieldProps[12]);

            //송신자명 파일전송업무의 책임이 있는 사람의 나타내는 ID를 Set한다.
            compileField(13, batchDoc.getBatchMsg().getHeader().getUserID(), this.al_FieldProps[13]);

            //송신자 암호 (정당한 송신자 확인을 위한 쌍방간 합의된 암호
            compileField(14, batchDoc.getBatchMsg().getHeader().getUserPassword(), this.al_FieldProps[14]);

            //송신 집계 내역 - 개별업무 종료(0600/003)시만 사용하는 Field로 전송된 Record Count를 Set한다.
            compileField(15, "", this.al_FieldProps[15]);
            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        batchDoc.getBatchMsg().getBody().setBlockNum(0);
        batchDoc.getBatchMsg().getBody().setSeqNum(0);
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<10; i++) { //은행연합회 전문의 헤더는 레코드 길이까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=10; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정형 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
                try {
                    return Integer.parseInt( telegramInfo.getProperty(TelegramKeys.TRCD_LEN) );
                } catch (Exception e) {
                	logger.info(e.getMessage(), e);
                    return 0;
                }
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.debug("{} getCalculatedLength> parameter is not FIELD_NO_LENGTH", logHeader);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=2; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += getCalculatedLength(1);
            REAL_SEND_LENGTH = SEND_LENGTH;
            REAL_SEND_LENGTH += ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }
    
    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
        	int fldLen = getCalculatedLength(idx);
            System.arraycopy((telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE) + "         ").getBytes(), 0, data, 0, fldLen );
            // 로깅을 위해
            byte[] fieldData = new byte[fldLen];
            System.arraycopy(data, 0, fieldData, 0, fldLen);
            this.al_Field.set( idx, fieldData);

            return fldLen;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }


    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(10);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(7);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getFieldValueString(12);
    }
}